import { derefContext } from "@thi.ng/hiccup/deref";
import { DEFAULT_IMPL } from "./default.js";
import { resolveRoot } from "./resolve.js";
const renderOnce = (tree, opts = {}, impl = DEFAULT_IMPL) => {
  opts = { root: "app", ...opts };
  opts.ctx = derefContext(opts.ctx, opts.autoDerefKeys);
  const root = resolveRoot(opts.root, impl);
  tree = impl.normalizeTree(opts, tree);
  if (!tree) return;
  opts.hydrate ? impl.hydrateTree(opts, root, tree) : impl.createTree(opts, root, tree);
};
export {
  renderOnce
};
